import { isDefined, isUndefined, isEqual } from '@collectable/core';
import { setTreeValue, removeTreeValue, updateMapEntry } from './named-externals';
var _nextIndex = 0;
export function setItem(key, value, keyMap, sortedValues, select) {
    var entry;
    updateMapEntry(arg => {
        if (isUndefined(arg)) {
            return entry = {
                index: ++_nextIndex,
                view: isDefined(select) ? select(value, key) : void 0,
                key,
                value
            };
        }
        return isEqual(value, arg.value) ? arg : entry = {
            index: arg.index,
            view: isDefined(select) ? select(value, key) : void 0,
            key,
            value
        };
    }, key, keyMap);
    if (isDefined(entry)) {
        setTreeValue(entry, null, sortedValues);
        return true;
    }
    return false;
}
export function unsetItem(key, keyMap, sortedValues) {
    var entry;
    updateMapEntry(arg => {
        if (isDefined(arg))
            entry = arg;
        return void 0;
    }, key, keyMap);
    if (isDefined(entry)) {
        removeTreeValue(entry, sortedValues);
        return true;
    }
    return false;
}

//# sourceMappingURL=assignment.js.map
