import { MappableIterator } from '@collectable/core';
import { keys } from '@collectable/red-black-tree';
export function iterate(map) {
    return keys(map._sortedValues);
}
function toKey(item) {
    return item.key;
}
function toValue(item) {
    return item.value;
}
function toPair(item) {
    return [item.key, item.value];
}
export function iterateKeys(map) {
    return new MappableIterator(keys(map._sortedValues), toKey);
}
export function iterateValues(map) {
    return new MappableIterator(keys(map._sortedValues), toValue);
}
export function iteratePairs(map) {
    return new MappableIterator(keys(map._sortedValues), toPair);
}

//# sourceMappingURL=iterate.js.map
